## apache2 2.4.7

=== CMakeLists.txt ===
# Licensed to the Apache Software Foundation (ASF) under one or more
# contributor license agreements.  See the NOTICE file distributed with
# this work for additional information regarding copyright ownership.
# The ASF licenses this file to You under the Apache License, Version 2.0
# (the "License"); you may not use this file except in compliance with
# the License.  You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#
# Read README.cmake before using this.

PROJECT(HTTPD C)

CMAKE_MINIMUM_REQUIRED(VERSION 2.8)

INCLUDE(CheckSymbolExists)
INCLUDE(CheckCSourceCompiles)

FIND_PACKAGE(LibXml2)
FIND_PACKAGE(Lua51)
FIND_PACKAGE(OpenSSL)
FIND_PACKAGE(ZLIB)

# Options for support libraries not supported by cmake-bundled FindFOO

# Default to using APR trunk (libapr-2.lib) if it exists in PREFIX/lib;
# otherwise, default to APR 1.x + APR-util 1.x
IF(EXISTS "${CMAKE_INSTALL_PREFIX}/lib/libapr-2.lib")
  SET(default_apr_libraries "${CMAKE_INSTALL_PREFIX}/lib/libapr-2.lib")
ELSEIF(EXISTS "${CMAKE_INSTALL_PREFIX}/lib/libapr-1.lib")
  SET(ldaplib "${CMAKE_INSTALL_PREFIX}/lib/apr_ldap-1.lib")
  IF(NOT EXISTS ${ldaplib})
    SET(ldaplib)
  ENDIF()
  SET(default_apr_libraries ${CMAKE_INSTALL_PREFIX}/lib/libapr-1.lib ${CMAKE_INSTALL_PREFIX}/lib/libaprutil-1.lib ${ldaplib})
ELSE()
  SET(default_apr_libraries)
ENDIF()

# PCRE names its libraries differently for debug vs. release builds.
# We can't query our own CMAKE_BUILD_TYPE at configure time.
# If the debug version exists in PREFIX/lib, default to that one.
IF(EXISTS "${CMAKE_INSTALL_PREFIX}/lib/pcred.lib")
  SET(default_pcre_libraries ${CMAKE_INSTALL_PREFIX}/lib/pcred.lib)
ELSE()
  SET(default_pcre_libraries ${CMAKE_INSTALL_PREFIX}/lib/pcre.lib)
ENDIF()

SET(APR_INCLUDE_DIR       "${CMAKE_INSTALL_PREFIX}/include" CACHE STRING "Directory with APR[-Util] include files")
SET(APR_LIBRARIES         ${default_apr_libraries}       CACHE STRING "APR libraries to link with")
SET(PCRE_INCLUDE_DIR      "${CMAKE_INSTALL_PREFIX}/include" CACHE STRING "Directory with PCRE include files")
SET(PCRE_LIBRARIES        ${default_pcre_libraries}      CACHE STRING "PCRE libraries to link with")
SET(LIBXML2_ICONV_INCLUDE_DIR     ""                     CACHE STRING "Directory with iconv include files for libxml2")
SET(LIBXML2_ICONV_LIBRARIES       ""                     CACHE STRING "iconv libraries to link with for libxml2")
# end support library configuration

# Misc. options
OPTION(INSTALL_PDB        "Install .pdb files (if generated)"  ON)
OPTION(INSTALL_MANUAL     "Install manual"                     ON)

SET(ENABLE_MODULES        "O"                            CACHE STRING "Minimum module enablement (e.g., \"i\" to build all but those without prerequisites)")
SET(WITH_MODULES          ""                             CACHE STRING "comma-separated paths to single-file modules to statically link into the server")
SET(EXTRA_INCLUDES        ""                             CACHE STRING "Extra include directories")
SET(EXTRA_LIBS            ""                             CACHE STRING "Extra libraries")
SET(EXTRA_COMPILE_FLAGS   ""                             CACHE STRING "Extra compile flags")

IF(NOT EXISTS "${APR_INCLUDE_DIR}/apr.h")
  MESSAGE(FATAL_ERROR "APR include directory ${APR_INCLUDE_DIR} is not correct.")
ENDIF()
FOREACH(onelib ${APR_LIBRARIES})
  IF(NOT EXISTS ${onelib})
    MESSAGE(FATAL_ERROR "APR library ${onelib} was not found.")
  ENDIF()
ENDFOREACH()

MACRO(DEFINE_WITH_BLANKS output_definition input_symbol input_value)
  IF(MSVC_IDE)
    SET(${output_definition} "-D${input_symbol}=\"${input_value}\"")
  ELSE()
    # assume command-line tool, where extra quotes must be added and escaped to
    # survive
    SET(${output_definition} "-D${input_symbol}=\"\\\"${input_value}\\\"\"")
  ENDIF()
ENDMACRO()

MACRO(GET_MOD_ENABLE_RANK macro_modname macro_mod_enable_val macro_output_rank)
  IF(${macro_mod_enable_val} STREQUAL "O")
    SET(${macro_output_rank} 0)
  ELSEIF(${macro_mod_enable_val} STREQUAL "i")
    SET(${macro_output_rank} 1)
  ELSEIF(${macro_mod_enable_val} STREQUAL "I")
    SET(${macro_output_rank} 2)
  ELSEIF(${macro_mod_enable_val} STREQUAL "a")
    SET(${macro_output_rank} 3)
  ELSEIF(${macro_mod_enable_val} STREQUAL "A")
    SET(${macro_output_rank} 4)
  ELSE()
    MESSAGE(FATAL_ERROR "Unexpected enablement value \"${macro_mod_enable_val}\" for ${macro_modname}")
  ENDIF()
ENDMACRO()

GET_MOD_ENABLE_RANK("ENABLE_MODULES setting" ${ENABLE_MODULES} enable_modules_rank)

# Figure out what APR/APU features are available
#
# CHECK_APR_FEATURE checks for features defined to 1 or 0 in apr.h or apu.h
# The symbol representing the feature will be set to TRUE or FALSE for 
# compatibility with the feature tests set by FindFooPackage.
#
# (unclear why CHECK_SYMBOL_EXISTS is needed, but I was getting "found" for anything 
# not defined to either 1 or 0)

MACRO(CHECK_APR_FEATURE which_define)
  CHECK_SYMBOL_EXISTS(${which_define} "${APR_INCLUDE_DIR}/apr.h;${APR_INCLUDE_DIR}/apu.h" tmp_${which_define})
  IF(${tmp_${which_define}})
    CHECK_C_SOURCE_COMPILES("#include \"${APR_INCLUDE_DIR}/apr.h\"
      #include \"${APR_INCLUDE_DIR}/apu.h\"
      int main() {
      #ifndef ${which_define}
      #error gobble
      #endif
      #if !${which_define}
      #error gobble
      #endif
      return 1;}" ${which_define})
  ELSE()
    SET(${which_define})
  ENDIF()
  IF(${${which_define}})
    SET(${which_define} TRUE)
  ELSE()
    SET(${which_define} FALSE)
  ENDIF()
ENDMACRO()

CHECK_APR_FEATURE(APR_HAS_XLATE)
CHECK_APR_FEATURE(APU_HAVE_CRYPTO)

# APR_HAS_LDAP is defined in apr_ldap.h, which exists only in apr 1.x, so use
# special code instead of CHECK_APR_FEATURE()
# As with CHECK_APR_FEATURE(), convert to a TRUE/FALSE result.
CHECK_C_SOURCE_COMPILES("#include \"${APR_INCLUDE_DIR}/apr.h\"
#include \"${APR_INCLUDE_DIR}/apr_ldap.h\"
int main() {
#if !APR_HAS_LDAP
#error gobble
#endif
return 1;}" APR_HAS_LDAP)
IF(${APR_HAS_LDAP})
  SET(APR_HAS_LDAP TRUE)
ELSE()
  SET(APR_HAS_LDAP FALSE)
ENDIF()

MESSAGE(STATUS "")
MESSAGE(STATUS "Summary of feature detection:")
MESSAGE(STATUS "")
MESSAGE(STATUS "LIBXML2_FOUND ............ : ${LIBXML2_FOUND}")
MESSAGE(STATUS "LUA51_FOUND .............. : ${LUA51_FOUND}")
MESSAGE(STATUS "OPENSSL_FOUND ............ : ${OPENSSL_FOUND}")
MESSAGE(STATUS "ZLIB_FOUND ............... : ${ZLIB_FOUND}")
MESSAGE(STATUS "APR_HAS_LDAP ............. : ${APR_HAS_LDAP}")
MESSAGE(STATUS "APR_HAS_XLATE ............ : ${APR_HAS_XLATE}")
MESSAGE(STATUS "APU_HAVE_CRYPTO .......... : ${APU_HAVE_CRYPTO}")
MESSAGE(STATUS "")

# Options for each available module
#   "A" ("A"ctive) means installed and active in default .conf, fail if can't be built
#   "I" ("I"nactive) means installed and inactive (LoadModule commented out) in default .conf, fail if can't be built
#   "O" ("O"mit) means not installed, no LoadModule
#   "a" - like "A", but ignore with a warning if any prereqs aren't available
#   "i" - like "I", but ignore with a warning if any prereqs aren't available

# Current heuristic for default enablement:
#
#   Module requires a prereq and           -> O
#   finding/usingprereq isn't implemented
#   yet
#
#   Module is included by default in       -> a if it has prereqs, A otherwise
#   autoconf-based build 
#
#   Module is included in                  -> i if it has prereqs, I otherwise
#   --enable-modules=most 
#
#   Otherwise                              -> O
#
SET(MODULE_LIST
  "modules/aaa/mod_access_compat+A+mod_access compatibility"
  "modules/aaa/mod_allowmethods+I+restrict allowed HTTP methods"
  "modules/aaa/mod_auth_basic+A+basic authentication"
  "modules/aaa/mod_auth_digest+I+RFC2617 Digest authentication"
  "modules/aaa/mod_auth_form+I+form authentication"
  "modules/aaa/mod_authn_anon+I+anonymous user authentication control"
  "modules/aaa/mod_authn_core+A+core authentication module"
  "modules/aaa/mod_authn_dbd+I+SQL-based authentication control"
  "modules/aaa/mod_authn_dbm+I+DBM-based authentication control"
  "modules/aaa/mod_authn_file+A+file-based authentication control"
  "modules/aaa/mod_authn_socache+I+Cached authentication control"
  "modules/aaa/mod_authnz_ldap+i+LDAP based authentication"
  "modules/aaa/mod_authz_core+A+core authorization provider vector module"
  "modules/aaa/mod_authz_dbd+I+SQL based authorization and Login/Session support"
  "modules/aaa/mod_authz_dbm+I+DBM-based authorization control"
  "modules/aaa/mod_authz_groupfile+A+'require group' authorization control"
  "modules/aaa/mod_authz_host+A+host-based authorization control"
  "modules/aaa/mod_authz_owner+I+'require file-owner' authorization control"
  "modules/aaa/mod_authz_user+A+'require user' authorization control"
  "modules/arch/win32/mod_isapi+I+isapi extension support"
  "modules/cache/mod_cache+I+dynamic file caching.  At least one storage management module (e.g. mod_cache_disk) is also necessary."
  "modules/cache/mod_cache_disk+I+disk caching module"
  "modules/cache/mod_cache_socache+I+shared object caching module"
  "modules/cache/mod_file_cache+I+File cache"
  "modules/cache/mod_socache_dbm+I+dbm small object cache provider"
  "modules/cache/mod_socache_dc+O+distcache small object cache provider"
  "modules/cache/mod_socache_memcache+I+memcache small object cache provider"
  "modules/cache/mod_socache_shmcb+I+ shmcb small object cache provider"
  "modules/cluster/mod_heartbeat+I+Generates Heartbeats"
  "modules/cluster/mod_heartmonitor+I+Collects Heartbeats"
  "modules/core/mod_macro+I+Define and use macros in configuration files"
  "modules/core/mod_watchdog+I+Watchdog module"
  "modules/database/mod_dbd+I+Apache DBD Framework"
  "modules/dav/fs/mod_dav_fs+I+DAV provider for the filesystem."
  "modules/dav/lock/mod_dav_lock+I+DAV provider for generic locking"
  "modules/dav/main/mod_dav+I+WebDAV protocol handling."
  "modules/debugging/mod_bucketeer+O+buckets manipulation filter.  Useful only for developers and testing purposes."
  "modules/debugging/mod_dumpio+I+I/O dump filter"
  "modules/echo/mod_echo+O+ECHO server"
  "modules/examples/mod_case_filter+O+Example uppercase conversion filter"
  "modules/examples/mod_case_filter_in+O+Example uppercase conversion input filter"
  "modules/examples/mod_example_hooks+O+Example hook callback handler module"
  "modules/examples/mod_example_ipc+O+Example of shared memory and mutex usage"
  "modules/filters/mod_buffer+I+Filter Buffering"
  "modules/filters/mod_charset_lite+i+character set translation"
  "modules/filters/mod_data+O+RFC2397 data encoder"
  "modules/filters/mod_deflate+i+Deflate transfer encoding support"
  "modules/filters/mod_ext_filter+I+external filter module"
  "modules/filters/mod_filter+A+Smart Filtering"
  "modules/filters/mod_include+I+Server Side Includes"
  "modules/filters/mod_proxy_html+i+Fix HTML Links in a Reverse Proxy"
  "modules/filters/mod_ratelimit+I+Output Bandwidth Limiting"
  "modules/filters/mod_reflector+O+Reflect request through the output filter stack"
  "modules/filters/mod_reqtimeout+A+Limit time waiting for request from client"
  "modules/filters/mod_request+I+Request Body Filtering"
  "modules/filters/mod_sed+I+filter request and/or response bodies through sed"
  "modules/filters/mod_substitute+I+response content rewrite-like filtering"
  "modules/filters/mod_xml2enc+i+i18n support for markup filters"
  "modules/generators/mod_asis+I+as-is filetypes"
  "modules/generators/mod_autoindex+A+directory listing"
  "modules/generators/mod_cgi+I+CGI scripts"
  "modules/generators/mod_info+I+server information"
  "modules/generators/mod_status+I+process/thread monitoring"

=== modules/core/test/Makefile ===
#
# $Id: Makefile 1435811 2013-01-20 10:07:44Z fabien $
#
# mod_macro non regression tests

# where is apache
APA.dir	= /tmp/apache

# apache executable with mod macro loaded
HTTPD = \
	$(APA.dir)/bin/httpd \
	  -C 'LoadModule macro_module modules/mod_macro.so' \
	  -C "Define PWD $$PWD/conf"

# default target
.PHONY: default
default: clean

# run all non regression tests
.PHONY: check
check: check-out

# result directory
OUT	= out
out:
	mkdir $@

# test cases & results
F.conf	= $(wildcard conf/test*.conf)
F.out	= $(F.conf:conf/%.conf=$(OUT)/%.out)

# run all tests
.PHONY: run-test
run-test: $(F.out)

# generate & compare in a separate directory
.PHONY: check-out
check-out: out
	$(RM) out/*.out
	$(MAKE) OUT=out run-test
	diff -r out/ ref/

# generate & compare in the same directory
.PHONY: check-ref
check-ref:
	$(RM) ref/*.out
	$(MAKE) OUT=ref run-test
	svn diff ref/

# run one test case
# filter output so that it is portable
# use '|' sed separator because $PWD will contain plenty '/'
$(OUT)/%.out: conf/%.conf
	{ \
	  echo "# testing with $<" ; \
	  $(HTTPD) -f $$PWD/$< 2>&1 ; \
	  echo "# exit: $$?" ; \
	} > $@.tmp ; \
	sed -e "s|$$PWD|.|g" \
	    -e "s|^\[[\.a-zA-Z0-9 :]*\] ||" \
	    -e "s|\[pid [0-9]*:tid [0-9]*] ||" \
	    $@.tmp > $@ ; \
	$(RM) $@.tmp

# cleanup
.PHONY: clean
clean:
	$(RM) *~
	$(RM) -r out

## apache2 2.2.21

=== debian/changelog ===
apache2 (2.2.21-5) unstable; urgency=low

  [ Arno Töll ]
  * Fix build failures introduced as regregression by the previous build. Debian
    buildds aren't rebuilding arch:all packages which caused problems for our
    unconditional copying into binary package. I was warned.

 -- Stefan Fritsch <sf@debian.org>  Thu, 29 Dec 2011 17:36:41 +0100

apache2 (2.2.21-4) unstable; urgency=low

  [ Stefan Fritsch ]

  * Security: Fix broken patch for CVE-2011-3607 (Integer overflow in
    ap_pregsub).
  * Optimize debian/rules again to improve build time by doing most work in a
    single parallelized "build-%" target.

  [ Arno Töll ]

  * Fix "Suggest removing DefaultType from apache2.conf" change the DefaultType
    from text/plain to None. This lets the browser guess a proper MIME type
    instead of being forced to treat a given file according to our default type
    (Closes: #440058)
  * Fix "add pre-rotate hook to logrotate script" execute scripts in
    /etc/logrotate.d/httpd-prerotate if available (Closes: #590096).
  * Fix "Hide /icons index" Disables indexes on the icon directory. By upgrading
    to Debian's 3.0/quilt source format also images don't need to be generated
    at build time anymore. Hence, the icon date can no longer lead to
    information disclosure (Closes: #649888).
  * Upgrade package to 3.0/quilt.
    + Remove uuencoded images, keep them in their binary format in debian/icons
    + Upgrade to quilt from dpatch and refresh all patches by keeping all hunks
      unchanged. Remove the `001_branding' patch by supplying -DPLATFORM at
      build time where needed Move the 200_cp_suexec.dpatch patch and
      202_suexec-custom.dpatch patch to debian/rules. 200_cp_suexec.dpatch was a
      script, not a patch which is not supported by quilt.
  * Rewrite debian/rules and base it on dh(1).
    + use overrides where possible, replace some debhelper calls by our own
      implementation where needed. That's required since the Apache package is
      compiled in parts several times for each MPM once.
    + move some install operations to the their respective .install files
    + Support dpkg-buildflags now, which also enables by default hardening
      flags. Thus, remove them from their explicit appearance in debian/rules
    + Remove DEB_BUILD_OPTIONS legacy support. It comes for free when using
      dh(1)/dpkg-buildflags(1).
  * Push debhelper compatibility to 8
  * Remove unused Lintian overrides for the Debian source package remove and
    redundant priorities in debian/control.
  * Add myself to Uploaders

 -- Stefan Fritsch <sf@debian.org>  Thu, 29 Dec 2011 12:09:14 +0100

apache2 (2.2.21-3) unstable; urgency=medium

  * Fix CVE-2011-4317: Prevent unintended pattern expansion in some
    reverse proxy configurations. (Similar to CVE-2011-3368, but different
    attack vector.)
  * Fix CVE-2011-3607: Integer overflow in ap_pregsub could cause segfault
    via malicious .htaccess. 
  * Mention dpkg-statoverride for changing permissions of suexec. LP: #897120
  * Fix broken link in docs. Closes: #650528
  * Remove Tollef Fog Heen, Thom May, and Peter Samuelson from uploaders.
    Thanks for your work in the past.

 -- Stefan Fritsch <sf@debian.org>  Sat, 03 Dec 2011 18:54:03 +0100

apache2 (2.2.21-2) unstable; urgency=high

  * Fix CVE-2011-3368: Prevent unintended pattern expansion in some
    reverse proxy configurations by strictly validating the request-URI.
  * Correctly set permissions of suexec.load even if umask is 0002 during
    build. LP: #872000

 -- Stefan Fritsch <sf@debian.org>  Tue, 11 Oct 2011 22:54:47 +0200

apache2 (2.2.21-1) unstable; urgency=low

  * New upstream release.
    - Fixes CVE-2011-3348: Possible denial of service in mod_proxy_ajp
      if combined with mod_proxy_balancer

 -- Stefan Fritsch <sf@debian.org>  Mon, 26 Sep 2011 18:16:11 +0200

apache2 (2.2.20-1) unstable; urgency=low

  * New upstream release.
  * Fix some regressions related to Range requests caused by the CVE-2011-3192
    fix. Closes: #639825
  * Add build-arch and build-indep rules targets to make Lintian happy.
  * Bump Standards-Version (no changes).

 -- Stefan Fritsch <sf@debian.org>  Sun, 04 Sep 2011 21:50:22 +0200

apache2 (2.2.19-2) unstable; urgency=high

  * Fix CVE-2011-3192: DoS by high memory usage for a large number of
    overlapping ranges.
  * Reduce default KeepAliveTimeout from 15 to 5 seconds. 
  * Use "linux-any" in build-deps. Closes: #634709
  * Improve reload message of a2enmod. Closes: #639291
  * Improve description of the prefork MPM. Closes: #634242
  * Mention .conf files in a2enmod man page. Closes: #634834

 -- Stefan Fritsch <sf@debian.org>  Mon, 29 Aug 2011 17:08:17 +0200

apache2 (2.2.19-1) unstable; urgency=low

  * New upstream release.
    - Makes apr-md5 the default algorithm for htpasswd, removing the 8
      character limit of the crypt()-algorithm. Closes: #539246
    - Fixes merging of IndexOptions. Closes: #394688
    - Documents why order of ProxyPass and <Proxy> blocks matters in the
      configuration. See "Workers" section in the mod_proxy documentation.
      Closes: #560020
  * For multiple instance setups, correctly determine the config dir in the
    init script if it is called via a start/stop link. Closes: #627061
  * Make a2enmod's restart hint more cut'n'paste friendly. LP: #770204
  * Make it clear in README.multiple-instances that the MPMs are shipped
    in the apache2.2-bin package.

 -- Stefan Fritsch <sf@debian.org>  Sun, 22 May 2011 10:21:21 +0200

apache2 (2.2.17-3) unstable; urgency=low

  * Fix compilation with OpenSSL without SSLv2 support. Closes: #622049
  * Fix link errors with -no-add-needed/--no-copy-dt-needed-entries in
    htpasswd/htdbm.

 -- Stefan Fritsch <sf@debian.org>  Sun, 10 Apr 2011 20:43:55 +0200

apache2 (2.2.17-2) unstable; urgency=high

  * New mpm_itk upstream version 2.2.17-01:
    - Fix CVE-2011-1176: If NiceValue was set, the default with no


=== debian/control ===
Source: apache2
Section: httpd
Priority: optional
Maintainer: Debian Apache Maintainers <debian-apache@lists.debian.org>
Uploaders: Stefan Fritsch <sf@debian.org>, Steinar H. Gunderson <sesse@debian.org>, Arno Töll <debian@toell.net>
Build-Depends: debhelper (>= 8), lsb-release, libaprutil1-dev (>= 1.3.4), libapr1-dev, openssl, libpcre3-dev, mawk, zlib1g-dev, libssl-dev (>= 0.9.8m), sharutils, libcap-dev [linux-any], autoconf
Build-Conflicts: autoconf2.13
Standards-Version: 3.9.2
Vcs-Browser: http://svn.debian.org/wsvn/pkg-apache/trunk/apache2
Vcs-svn: svn://svn.debian.org/pkg-apache/trunk/apache2
Homepage: http://httpd.apache.org/

Package: apache2.2-common
Architecture: any
Depends: ${misc:Depends}, apache2.2-bin (= ${binary:Version}), apache2-utils, mime-support, lsb-base, procps [!hurd-i386], perl
Recommends: ssl-cert
Suggests: www-browser, apache2-doc, apache2-suexec | apache2-suexec-custom
Conflicts: apache2-common, apache
Replaces: apache2-common
Description: Apache HTTP Server common files
 The Apache Software Foundation's goal is to build a secure, efficient and
 extensible HTTP server as standards-compliant open source software. The
 result has long been the number one web server on the Internet.
 .
 This package contains the configuration and support scripts.
 However, it does *not* include the server itself; for this you need to
 install one of the apache2-mpm-* packages, such as worker or prefork.

Package: apache2.2-bin
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: apache2.2-common (<< 2.2.11-5~)
Replaces: apache2.2-common (<< 2.2.14-2~)
Description: Apache HTTP Server common binary files
 The Apache Software Foundation's goal is to build a secure, efficient and
 extensible HTTP server as standards-compliant open source software. The
 result has long been the number one web server on the Internet.
 .
 This package contains all binaries but no configuration or support scripts.
 To get a stand-alone server, you need to install one of the apache2-mpm-*
 packages, such as worker or prefork. Other packages like gnome-user-share
 may bring their own Apache configuration, though.

Package: apache2-mpm-worker
Architecture: any
Depends: ${misc:Depends}, apache2.2-common (= ${binary:Version}), apache2.2-bin (= ${binary:Version})
Provides: apache2-mpm, apache2, httpd, httpd-cgi
Conflicts: apache2-mpm, apache2-common
Description: Apache HTTP Server - high speed threaded model
 Each Apache Multi-Processing Module provides a different "flavor" of
 web server binary, compiled with a different processing model.
 .
 The worker MPM provides the default threaded implementation. It is
 recommended especially for high-traffic sites because it is faster
 and has a smaller memory footprint than the traditional prefork MPM.

Package: apache2-mpm-prefork
Architecture: any
Depends: ${misc:Depends}, apache2.2-common (= ${binary:Version}), apache2.2-bin (= ${binary:Version})
Provides: apache2-mpm, apache2, httpd, httpd-cgi
Conflicts: apache2-mpm, apache2-common
Description: Apache HTTP Server - traditional non-threaded model
 Each Apache Multi-Processing Module provides a different "flavor" of
 web server binary, compiled with a different processing model.
 .
 The prefork MPM provides a non-threaded implementation using a variable
 number of processes where each process handles only one connection
 at the same time. It is not as fast as threaded models, but is considered to
 be more stable. It is appropriate for sites that need to maintain
 compatibility with non-thread-safe libraries, and is the best MPM for
 isolating each request, so that a problem with a single request will not
 affect any other.

Package: apache2-mpm-event
Architecture: any
Depends: ${misc:Depends}, apache2.2-common (= ${binary:Version}), apache2.2-bin (= ${binary:Version})
Provides: apache2-mpm, apache2, httpd, httpd-cgi
Conflicts: apache2-mpm, apache2-common
Description: Apache HTTP Server - event driven model
 Each Apache Multi-Processing Module provides a different "flavor" of
 web server binary, compiled with a different processing model.
 .
 The event MPM is designed to allow more requests to be served
 simultaneously by passing off some processing work to supporting
 threads, freeing up the main threads to work on new requests. It is
 especially suitable for sites that see extensive KeepAlive traffic.
 .
 This MPM is experimental and less tested than the worker and prefork MPMs.
 
Package: apache2-mpm-itk
Depends: ${misc:Depends}, apache2.2-common (= ${binary:Version}), apache2.2-bin (= ${binary:Version})
Provides: apache2-mpm, apache2, httpd, httpd-cgi
Conflicts: apache2-mpm, apache2-common
Architecture: any
Priority: extra
Description: multiuser MPM for Apache 2.2
 The ITK Multi-Processing Module (MPM) works in about the same way as the
 classical "prefork" module (that is, without threads), except that it allows
 you to constrain each individual vhost to a particular system user. This
 allows you to run several different web sites on a single server without
 worrying that they will be able to read each others' files. This is a
 third-party MPM that is not included in the normal Apache httpd.
 .
 Please note that this MPM is somewhat less tested than the MPMs that come with
 Apache itself.

Package: apache2-utils
Architecture: any
Replaces: apache2-common, apache-utils (<< 1.3.33-4)
Conflicts: apache-common (<< 1.3.28.0.1-1)
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: utility programs for webservers
 Provides some add-on programs useful for any webserver.  These include:
  - ab (Apache benchmark tool)
  - logresolve (Resolve IP addresses to hostname in logfiles)
  - htpasswd (Manipulate basic authentication files)
  - htdigest (Manipulate digest authentication files)
  - dbmmanage (Manipulate basic authentication files in DBM format, using perl)
  - htdbm (Manipulate basic authentication files in DBM format, using APR)
  - rotatelogs (Periodically stop writing to a logfile and open a new one)
  - split-logfile (Split a single log including multiple vhosts)
  - checkgid (Checks whether the caller can setgid to the specified group)
  - check_forensic (Extract mod_log_forensic output from Apache log files)

Package: apache2-suexec
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, apache2.2-common
Conflicts: apache2-suexec, apache-common
Replaces: apache2-suexec
Description: Standard suexec program for Apache 2 mod_suexec
 Provides the standard suexec helper program for mod_suexec. This version is 
 compiled with document root /var/www and userdir suffix public_html. If you
 need different settings, use the package apache2-suexec-custom.

Package: apache2-suexec-custom
Priority: extra
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, apache2.2-common
Provides: apache2-suexec
Conflicts: apache2-suexec, apache-common
Replaces: apache2-suexec
Description: Configurable suexec program for Apache 2 mod_suexec
 Provides a customizable version of the suexec helper program for mod_suexec.
 This is not the version from upstream, but can be configured with a
 configuration file. 
 .
 If you do not need non-standard document root or userdir settings, it is
 recommended that you use the standard suexec helper program from the
 apache2-suexec package instead.

Package: apache2
Architecture: any
Depends: ${misc:Depends}, apache2-mpm-worker (= ${binary:Version}) | apache2-mpm-prefork (= ${binary:Version}) | apache2-mpm-event (= ${binary:Version}) | apache2-mpm-itk (= ${binary:Version}), apache2.2-common (= ${binary:Version})
Description: Apache HTTP Server metapackage         
 The Apache Software Foundation's goal is to build a secure, efficient and
 extensible HTTP server as standards-compliant open source software. The
 result has long been the number one web server on the Internet.
 .
 It features support for HTTPS, virtual hosting, CGI, SSI, IPv6, easy
 scripting and database integration, request/response filtering, many
 flexible authentication schemes, and more.

Package: apache2-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Description: Apache HTTP Server documentation
 This package provides the documentation for Apache 2. For more details
 see the apache2 package description.

Package: apache2-prefork-dev
Architecture: any
Depends: ${misc:Depends}, apache2.2-common (= ${binary:Version}), openssl, libaprutil1-dev
Conflicts: apache2-threaded-dev
Priority: extra
Description: Apache development headers - non-threaded MPM
 This package provides the development headers and apxs2 binary for
 apache2-mpm-prefork; see the apache2 package description for more details.
 .
 This should only be used when you absolutely *must* support a non-threaded
 environment (for PHP, for example).

Package: apache2-threaded-dev
Architecture: any
Depends: ${misc:Depends}, apache2.2-common (= ${binary:Version}), openssl, libaprutil1-dev
Conflicts: apache2-prefork-dev
Provides: apache2-dev
Priority: extra
Description: Apache development headers - threaded MPM
 This package provides the development headers and apxs2 binary for
 threaded versions of apache2; see the apache2 package description
 for more details.

Package: apache2-dbg
Section: debug
Priority: extra
Architecture: any
Depends: ${misc:Depends}, apache2.2-bin (= ${binary:Version})
Description: Apache debugging symbols
 This package includes the debugging symbols for Apache 2.
 See /usr/share/doc/apache2.2-common/README.backtrace for more information.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Some caveats:
# 1) This rules file is based on the short dh(1) form. However, it needs a lot
#    of overrides to achieve what we want. The basic outline is to build the
#    source three four times, once for each supported MPM.
# 2) The modules aren't built for all MPMs. Given that the builtin modules are
#    the same for all MPMs it is possible to cross-load a module built for one
#    MPM in any other. Hence, we build modules only for the worker MPM and reuse
#    it for all the remaining MPMs. The worker $(DEFAULT_MPM) is the basic
#    installation path where packages are being built from. From the remaining
#    MPMs only the respective binaries are taken. Development header are
#    similary taken from the prefork MPM, although the threaded MPMs need their
#    own headers partially.
# 3) The ITK MPM needs modification in the source tree. Hence it is absolutely
#    necessary to copy the source tree before applying patches which enable the
#    ITK. For the remaining MPMs that's not stricly necessary
# 4) There are being built two flavors of suexec. One is supplied upstream,
#    another one is a Debian improvement which allows customization. The latter
#    suexec-custom binary is built from a copy-and-patched suexec source at
#    compile time.
# 5) Special care must be taken to avoid having -DPLATFORM defined for apxs2.
# 6) dh_install is not powerful enough to us. We need to copy and move into
#    (future) binary packages.See various dh_install* overrides to get the idea.
# 7) BEWARE arch:indep ONLY BUILDS (dpkg-buildpackage -A) ARE KNOWN TO BE BROKEN
#    FOR NOW
#
# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

BUILD_DIR=debian/build-tree
INSTALL_DIR_RELATIVE=install-tree
INSTALL_DIR=debian/$(INSTALL_DIR_RELATIVE)
LSB_RELEASE := $(shell lsb_release -i -s)
DEFAULT_MPM=$(INSTALL_DIR)/worker

MPMS=worker prefork event itk

AP2_COMMON_CONFARGS = --enable-layout=Debian --enable-so \
                      --with-program-name=apache2  \
                      --with-ldap=yes --with-ldap-include=/usr/include \
                      --with-ldap-lib=/usr/lib \
                      --with-suexec-caller=www-data \
                      --with-suexec-bin=/usr/lib/apache2/suexec \
                      --with-suexec-docroot=/var/www \
                      --with-suexec-userdir=public_html \
                      --with-suexec-logfile=/var/log/apache2/suexec.log \
                      --with-suexec-uidmin=100 \
                      --enable-suexec=shared \
                      --enable-log-config=static --enable-logio=static \
                      --with-apr=/usr/bin/apr-1-config \
                      --with-apr-util=/usr/bin/apu-1-config \
                      --with-pcre=yes \
                      --enable-pie

AP2_worker_CONFARGS = --enable-authn-alias=shared --enable-authnz-ldap=shared  \
                      --enable-disk-cache=shared --enable-cache=shared \
                      --enable-mem-cache=shared --enable-file-cache=shared \
                      --enable-cern-meta=shared --enable-dumpio=shared --enable-ext-filter=shared \
                      --enable-charset-lite=shared --enable-cgi=shared \
                      --enable-dav-lock=shared --enable-log-forensic=shared \
                      --enable-ldap=shared --enable-proxy=shared \
                      --enable-proxy-connect=shared --enable-proxy-ftp=shared \
                      --enable-proxy-http=shared --enable-proxy-ajp=shared \
                      --enable-proxy-scgi=shared \
                      --enable-proxy-balancer=shared --enable-ssl=shared \
                      --enable-authn-dbm=shared --enable-authn-anon=shared \
                      --enable-authn-dbd=shared --enable-authn-file=shared \
                      --enable-authn-default=shared --enable-authz-host=shared \
                      --enable-authz-groupfile=shared --enable-authz-user=shared \
                      --enable-authz-dbm=shared --enable-authz-owner=shared \
                      --enable-authnz-ldap=shared --enable-authz-default=shared \
                      --enable-auth-basic=shared --enable-auth-digest=shared \
                      --enable-dbd=shared --enable-deflate=shared \
                      --enable-include=shared --enable-filter=shared \
                      --enable-env=shared --enable-mime-magic=shared \
                      --enable-expires=shared --enable-headers=shared \
                      --enable-ident=shared --enable-usertrack=shared \
                      --enable-unique-id=shared --enable-setenvif=shared \
                      --enable-version=shared --enable-status=shared \
                      --enable-autoindex=shared --enable-asis=shared \
                      --enable-info=shared --enable-cgid=shared \
                      --enable-dav=shared --enable-dav-fs=shared \
                      --enable-vhost-alias=shared --enable-negotiation=shared \
                      --enable-dir=shared --enable-imagemap=shared \
                      --enable-actions=shared --enable-speling=shared \
                      --enable-userdir=shared --enable-alias=shared \
                      --enable-rewrite=shared --enable-mime=shared \
                      --enable-substitute=shared  --enable-reqtimeout=shared
AP2_prefork_CONFARGS=--enable-modules=none
AP2_event_CONFARGS=$(AP2_prefork_CONFARGS)
AP2_itk_CONFARGS=$(AP2_prefork_CONFARGS)

AP2_CFLAGS = -pipe -I/usr/include/xmltok -I/usr/include/openssl -Wall $(shell dpkg-buildflags --get CFLAGS)
AP2_LDFLAGS = -Wl,--as-needed $(shell dpkg-buildflags --get LDFLAGS)
AP2_CPPFLAGS = -DPLATFORM='\"$(LSB_RELEASE)\"'  $(shell dpkg-buildflags --get CPPFLAGS)
CONFFLAGS += ac_cv_prog_AWK=mawk ac_cv_prog_LYNX_PATH=www-browser

ifeq (,$(findstring nostrip,$(DEB_BUILD_OPTIONS)))
DEB_BUILD_STRIP = yes
endif

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
  NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
  BUILDMAKEFLAGS = -j$(NUMJOBS)
endif

prepare-custom-suexec:
	cp support/suexec.c support/suexec-custom.c
	patch -p1 < debian/patches/202_suexec-custom

unapply-custom-suexec:
	rm -f support/suexec-custom.c

override_dh_auto_clean: unapply-custom-suexec
	rm -rf $(BUILD_DIR)
	rm -rf $(INSTALL_DIR)
	rm -f debian/tmp

build-%:
	mkdir "$(BUILD_DIR)/$*"
	cp -a `find . -maxdepth 1 -mindepth 1 -not -name debian` $(BUILD_DIR)/$*
	set -ex	;										\
	if [ $* = itk ] ; then                                                                  \
		cd $(BUILD_DIR)/$* ;                                                            \
		mkdir server/mpm/experimental/itk/ ;                                            \
		cp server/mpm/prefork/* server/mpm/experimental/itk/ ;                          \
		mv server/mpm/experimental/itk/prefork.c server/mpm/experimental/itk/itk.c ;    \
												\
		for PATCH in `tail -n +2 ../../mpm-itk/patches/series`; do                      \
			echo Applying $$PATCH ... ;                                             \
			patch -p1 < ../../mpm-itk/patches/$$PATCH ;                             \
			echo ;                                                                  \
		done ;                                                                          \
												\
		autoheader ;                                                                    \
		autoconf ;                                                                      \
	fi ;
	cd $(BUILD_DIR)/$* && ./configure \
		$(AP2_COMMON_CONFARGS) --with-mpm=$* $(AP2_$(*)_CONFARGS) $(CONFFLAGS) \
		CFLAGS="$(AP2_CFLAGS)" CPPFLAGS="$(AP2_CPPFLAGS)" LDFLAGS="$(AP2_LDFLAGS)"
	dh_auto_build -D "$(BUILD_DIR)/$*"
	cd "$(BUILD_DIR)/$*" && ./apache2 -l |grep -v $* > mods.list
	# force one process since mkdir.sh used by 'make install' is not
	# reliable otherwise
	dh_auto_install -D "$(BUILD_DIR)/$*" --destdir="$(INSTALL_DIR)/$*" -- -j1

## apache2 2.2.22

=== debian/changelog ===
apache2 (2.2.22-1) unstable; urgency=medium

  [ Stefan Fritsch ]
  * New upstream release, urgency medium due to security fixes:
    - Fix CVE-2012-0021: mod_log_config: DoS with '%{cookiename}C' log format
    - Fix CVE-2012-0031: Unprivileged child process could cause the parent to
      crash at shutdown
    - Fix CVE-2012-0053: Exposure of "httpOnly" cookies in code 400 error
      message.
  * Move httxt2dbm to apache2-utils
  * Adjust debian/control to point to new git repository.

  [ Arno Töll ]
  * Fix "typo in /etc/apache2/apache2.conf" (Closes: #653801)

 -- Stefan Fritsch <sf@debian.org>  Wed, 01 Feb 2012 21:49:04 +0100

=== debian/control ===
--- 
+++ 
@@ -6,8 +6,8 @@
 Build-Depends: debhelper (>= 8), lsb-release, libaprutil1-dev (>= 1.3.4), libapr1-dev, openssl, libpcre3-dev, mawk, zlib1g-dev, libssl-dev (>= 0.9.8m), sharutils, libcap-dev [linux-any], autoconf
 Build-Conflicts: autoconf2.13
 Standards-Version: 3.9.2
-Vcs-Browser: http://svn.debian.org/wsvn/pkg-apache/trunk/apache2
-Vcs-svn: svn://svn.debian.org/pkg-apache/trunk/apache2
+Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-apache/apache2.git
+Vcs-Git: git://git.debian.org/git/pkg-apache/apache2.git
 Homepage: http://httpd.apache.org/
 
 Package: apache2.2-common
@@ -106,7 +106,7 @@
 
 Package: apache2-utils
 Architecture: any
-Replaces: apache2-common, apache-utils (<< 1.3.33-4)
+Replaces: apache2-common, apache-utils (<< 1.3.33-4), apache2.2-bin (<< 2.2.22-1~)
 Conflicts: apache-common (<< 1.3.28.0.1-1)
 Depends: ${misc:Depends}, ${shlibs:Depends}
 Description: utility programs for webservers
@@ -121,6 +121,7 @@
   - split-logfile (Split a single log including multiple vhosts)
   - checkgid (Checks whether the caller can setgid to the specified group)
   - check_forensic (Extract mod_log_forensic output from Apache log files)
+  - httxt2dbm (Generate dbm files for use with RewriteMap)
 
 Package: apache2-suexec
 Architecture: any

=== debian/watch ===
version=3
http://www.apache.org/dist/httpd/httpd-(2\.2.*)\.tar\.gz
